package com.nabisoft.tutorials.jerseymoxy.jaxrs.resource;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import com.nabisoft.tutorials.jerseymoxy.model.Message;

@Path("/message")
public class MessageResource {
    
    @GET
    @Path("ping")
    public String getServerTime() {
        return "received ping on "+new Date().toString();
    }
    
    @GET
    @Produces({MediaType.APPLICATION_JSON})  //add MediaType.APPLICATION_XML if you want XML as well (don't forget @XmlRootElement)
    public List<Message> getAllMessages() throws Exception{
        List<Message> messages = new ArrayList<>();
        
        Message m = new Message();
        m.setDate(new Date());
        m.setFirstName("Nabi");
        m.setAge(30);
        m.setText("Hello World!");
        messages.add(m);

        return messages; //do not use Response object because this causes issues when generating XML automatically
    }
    
    @POST
    @Consumes({MediaType.APPLICATION_JSON})
    @Produces({MediaType.TEXT_PLAIN})
    @Path("/post")
    public String postMessage(Message msg) throws Exception{
        return "ok";
    }
}